DevExtreme jQuery/JS - Custom Sources
Access to a custom data source is configured using the CustomStore component. DevExtreme provides ASP.NET and PHP extensions that help configure it and implement server-side data processing. You can also use the third-party extension for MongoDB.
You need to configure the CustomStore in detail for accessing a server built on another technology. Data in this situation can be processed on the client or server. In the former case, switch the CustomStore to the raw mode and load all data from the server in the load function as shown in the next example.
- $(function() {
- $("#pieChartContainer").dxPieChart({
- dataSource: new DevExpress.data.DataSource({
- store: new DevExpress.data.CustomStore({
- loadMode: "raw",
- load: function () {
- return $.getJSON('https://mydomain.com/MyDataService');
- }
- }),
- paginate: false
- })
- });
- });
In the latter case, use the CustomStore's load function to send data processing settings to the server. These settings are passed as a parameter to the load function and depend on the operations (filtering, sorting, etc.) that you have enabled in the DataSource. The following settings are relevant for the PieChart:
Sorting settings: sort
Present if the DataSource's sort option is set.Filtering settings: filter
Present if the DataSource's filter option is set.Searching settings: searchExpr, searchOperation, and searchValue
Present if corresponding options are set in the DataSource.
After receiving these settings, the server should apply them to data and send back an object with the following structure:
- {
- data: [ ... ] // result data objects
- }
This example shows how to make a query for data.
- $(function() {
- $("#pieChartContainer").dxPieChart({
- dataSource: new DevExpress.data.DataSource({
- store: new DevExpress.data.CustomStore({
- load: function(loadOptions) {
- var d = $.Deferred(),
- params = {};
- [
- "sort",
- "filter",
- "searchExpr",
- "searchOperation",
- "searchValue"
- ].forEach(function(i) {
- if(i in loadOptions && isNotEmpty(loadOptions[i]))
- params[i] = JSON.stringify(loadOptions[i]);
- });
- $.getJSON("http://mydomain.com/MyDataService", params)
- .done(function(result) {
- // Here, you can perform operations unsupported by the server
- // or any other operations on the retrieved data
- d.resolve(result.data);
- });
- return d.promise();
- }
- }),
- paginate: false
- })
- });
- });
- function isNotEmpty(value) {
- return value !== undefined && value !== null && value !== "";
- }
See Also
If you have technical questions, please create a support ticket in the DevExpress Support Center.

DevExtreme Angular - Custom Sources

DevExtreme provides the CustomStore component, a flexible instrument that allows you to configure data access manually, for consuming data from any source. The following extensions for ASP.NET and PHP servers simplify the task of configuring the CustomStore and implement server-side data processing as well:

You need to configure the CustomStore in detail for accessing a server built on another technology. Data in this situation can be processed on the client or server. In the former case, switch the CustomStore to the raw mode and load all data from the server in the load function as shown in the next example.

TypeScript
HTML
  • import { ..., Inject } from '@angular/core';
  • import { Http, HttpModule } from '@angular/http';
  • import { DxPieChartModule } from 'devextreme-angular';
  • import DataSource from 'devextreme/data/data_source';
  • import CustomStore from 'devextreme/data/custom_store';
  • import 'rxjs/add/operator/toPromise';
  • // ...
  • export class AppComponent {
  • pieChartDataSource: any = {};
  • constructor(@Inject(Http) http: Http) {
  • this.pieChartDataSource = new DataSource({
  • store: new CustomStore({
  • loadMode: "raw",
  • load: function () {
  • return http.get('http://mydomain.com/MyDataService')
  • .toPromise()
  • .then(response => {
  • return response.json();
  • });
  • }
  • }),
  • paginate: false
  • });
  • }
  • }
  • @NgModule({
  • imports: [
  • // ...
  • DxPieChartModule,
  • HttpModule
  • ],
  • // ...
  • })
  • <dx-pie-chart
  • [dataSource]="pieChartDataSource">
  • </dx-pie-chart>

In the latter case, use the CustomStore's load function to send data processing settings to the server. These settings are passed as a parameter to the load function and depend on the operations (filtering, sorting, etc.) that you have enabled in the DataSource. The following settings are relevant for the PieChart:

  • sort: Array
    Defines sorting parameters. Present if the DataSource's sort option is set. Multiple parameters apply to the data in sequence to implement multi-level sorting. Contains objects of the following structure:

    • { selector: "field", desc: true/false }
  • filter: Array
    Defines filtering parameters. Present if the DataSource's filter option is set. Possible variants:

    • Binary filter

      • [ "field", "=", 3 ]
    • Unary filter

      • [ "!", [ "field", "=", 3 ] ]
    • Complex filter

      • [
      • [ "field", "=", 10 ],
      • "and",
      • [
      • [ "otherField", "<", 3 ],
      • "or",
      • [ "otherField", ">", 11 ]
      • ]
      • ]

    See the Filtering topic for more details.

  • searchExpr, searchOperation and searchValue: Strings
    Another way to define a filter restricted to one criterion. Present if corresponding options are set in the DataSource.

After receiving these settings, the server should apply them to data and send back an object of the following structure:

  • {
  • data: [ ... ] // result data objects
  • }

This example shows how to make a query for data.

TypeScript
HTML
  • import { ..., Inject } from '@angular/core';
  • import { Http, HttpModule, URLSearchParams } from '@angular/http';
  • import { DxPieChartModule } from 'devextreme-angular';
  • import DataSource from 'devextreme/data/data_source';
  • import CustomStore from 'devextreme/data/custom_store';
  • import 'rxjs/add/operator/toPromise';
  • // ...
  • export class AppComponent {
  • pieChartDataSource: any = {};
  • constructor(@Inject(Http) http: Http) {
  • this.pieChartDataSource = new DataSource({
  • store: new CustomStore({
  • load: function (loadOptions) {
  • let params: URLSearchParams = new URLSearchParams();
  • params.set("sort", loadOptions.sort ? JSON.stringify(loadOptions.sort) : "");
  • params.set("filter", loadOptions.filter ? JSON.stringify(loadOptions.filter) : "");
  • params.set("searchExpr", loadOptions.searchExpr ? JSON.stringify(loadOptions.searchExpr) : "");
  • params.set("searchOperation", loadOptions.searchOperation);
  • params.set("searchValue", loadOptions.searchValue);
  • return http.get('http://mydomain.com/MyDataService', {
  • search: params
  • })
  • .toPromise()
  • .then(response => {
  • var json = response.json();
  • // Here, you can perform operations unsupported by the server
  • // or any other operations on the retrieved data
  • return json.items
  • });
  • }
  • })
  • });
  • }
  • }
  • @NgModule({
  • imports: [
  • // ...
  • DxPieChartModule,
  • HttpModule
  • ],
  • // ...
  • })
  • <dx-pie-chart ...
  • [dataSource]="pieChartDataSource">
  • </dx-pie-chart>
See Also